;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;
;  Zig-Zags by "Noice"
;
;================================

@DFile=400C
@Frames=4034

	LD HL,(DFile)
	LD BC,026F		;623
	ADD HL,BC
	INC BC
@Lb4052
	LD (HL),76		;Fill first 623 bytes of DFile with N/L chrs
	DEC HL
	DEC BC
	LD A,B
	OR C
	JR NZ Lb4052
				;Note: all the printing is hidden
				;from view because of the first 24
				;bytes of DFile being N/L chrs.
				;
				;Print "Noice" sction
				;
	LD HL,(DFile)		;Get DFile
	LD BC,01F1		;Offset to print position, 497
	ADD HL,BC		;Print position
	LD DE,Noice		;"Noice" data
	LD B,05
@Lb4066
	LD C,B			;C=Lines done counter
	LD B,09			;Print left margin 
@Lb4069
	LD (HL),00		;Print 9 " "
	INC HL
	DJNZ Lb4069
	LD B,0F			;B=15=chrs to print
@Lb4070
	LD A,(DE)		;Print "Noice"
	LD (HL),A
	INC HL
	INC DE
	DJNZ Lb4070
	LD B,C			;B=C=Line counter
	DJNZ Lb4066		;Loop until C,B=0
				;Print "ZigZags" section, still hidden
@ZigZag
	LD DE,(DFile)		;Get DFile
	LD A,76
	LD (DE),A 		;Set 1st N/L chr
	INC DE 			;Start DFile+1
	LD B,0F 		;Line count
@Lb4083
	LD A,B 			;Generate a random number
	RL A 
	RL A 
	LD C,A 
	LD A,(Frames)
	ADD A,C 
	AND 3F 			;Upper limit is 63
	PUSH BC 
	LD C,A 			;BC=0 to 63
	LD B,00 
	LD HL,Group02		;Addr of Group 2, offsets
	ADD HL,BC 		;Addr of offset
	LD A,(HL) 		;Get offset
	LD C,A 			;BC=offset
	LD HL,Group01		;Addr of Group 1, chrs
	ADD HL,BC 		;Source=Group 1+offset (BC), Destination=DFile
	LD BC,0020		;Byte count 32 
	LDIR 			;Print line
				;
				;Starting here the printing starts to appear, but not the
				;"Noice" section yet because all the N/L chrs from above
				;haven't been overwritten yet.
				;
	LD A,76
	LD (DE),A 		;Restore N/L chr
	INC DE 			;Start of next line
	POP BC 
	DJNZ Lb4083		;Loop until B=0
				;"Noice" now appears
	JP ZigZag		;Start the show

@Group01			;Group 1 data consists of chr strings to print
				;starting at a Group 2 offset and 32 bytes
				;long
	80 80 80 80 80 80 80 80
	80 80 80 80 80 8A 89 8A
	08 09 0A 09 00 00 00 0A
	09 0A 08 89 8A 89 80 80
	80 80 80 80 80 80 80 80
	80 80 80 80
				;Group 2 data consists offsets into Group 1
@Group02
	06 06 07 07 08 08 09 09
	0A 0A 0A 0B 0B 0B 0B 0B
	0B 0B 0B 0B 0B 0B 0A 0A
	0A 09 09 08 08 07 07 06
	05 05 04 04 03 03 02 02
	01 01 01 00 00 00 00 00
	00 00 00 00 00 00 01 01
	01 02 02 03 03 04 04 05
@Noice
	07 03 03 07 03 03 07 84
	03 03 84 03 03 84 76 05
	87 00 05 87 00 82 81 00
	04 85 00 83 81 76 05 85
	00 05 85 00 05 85 00 07
	84 00 83 82 76 05 85 00
	05 00 00 05 85 00 00 85
	00 00 85 76 03 03 03 03
	03 03 03 03 03 03 03 03
	03 03